Option Explicit

'############## VBSConverter ########################################################################################
'#                                                                                                                  #
'# Copyright:   Henry Schneider 2012                                                                                #
'# Creator:     Henry Schneider (HoBLila)           Abteilung:                                                      #
'# Date:        2012-08-20                          Version:    0.0.1.0                                             #
'# Autors:      Henry Schneider (HoBLila)           lila(at)lilashome.de                                            #
'#                                                                                                                  #
'# Description: Generiert VBS-Programme aus VBA-Code                                                                #
'#                                                                                                                  #
'# Changes:                                                                                                         #
'#                                                                                                                  #
'# License:     Copyright (C) 2012  Henry Schneider                                                                 #
'#                                                                                                                  #
'#              This program is free software; you can redistribute it and/or modify it under the terms             #
'#              of the GNU General Public License as published by the Free Software Foundation;                     #
'#              either version 3 of the License, or (at your option) any later version.                             #
'#                                                                                                                  #
'#              This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;           #
'#              without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.           #
'#              See the GNU General Public License for more details.                                                #
'#                                                                                                                  #
'#              You should have received a copy of the GNU General Public License along with this program;          #
'#              if not, see <http://www.gnu.org/licenses/>.                                                         #
'#                                                                                                                  #
'####################################################################################################################

Private priv_arrOfDeclarations()'    As String

'Sub CATMain()

    Dim boolStart   'As Boolean
    Dim filesWork   'As Object
    Dim fileWork    'As Object
    Dim fileNew     'As Object
    Dim folderWork  'As Object
    Dim fsoWork     'As Object
    Dim sFileIn     'As String
    Dim sFolder     'As String
    Dim sHeadIn     'As String
    Dim sHeadModule 'As String
    Dim sLine       'As String
    Dim sTotal      'As String
    Dim tSreamWork  'As Object
    Dim tSreamNew   'As Object
    
    Call fillArrOfDeclarations
    
    sFolder = BrowseFolder("", False)
    sHeadModule = InputBox("Bitte Namen des Hauptmoduls eingeben", "Head module", "modMain.bas")
    If (sFolder = vbNullString) Then WScript.Quit'Exit Sub
    Set fsoWork = CreateObject("Scripting.FileSystemObject")
    Set folderWork = fsoWork.GetFolder(sFolder)
    Set filesWork = folderWork.Files
    
    If (fsoWork.FileExists(sFolder & "\" & "VBSConverter.ini")) Then
    
        Set tSreamWork = fsoWork.OpenTextFile(sFolder & "\" & "VBSConverter.ini", 1)
        
        Do Until tSreamWork.AtEndOfStream
        
            ReDim Preserve priv_arrOfDeclarations(UBound(priv_arrOfDeclarations) + 1)
            priv_arrOfDeclarations(UBound(priv_arrOfDeclarations)) = tSreamWork.ReadLine
        
        Loop
    
    End If
    
    For Each fileWork In filesWork
    
        boolStart = False
        
        If (fileWork.Name = "VBSConverter.ini") Then
    
        ElseIf (Not (Right(fileWork.Name, 4) = ".vbs")) Then
        
            sFileIn = vbNullString
            
            If (Right(fileWork.Name, 4) = ".cls") Then
            
                sFileIn = "Class " & Left(fileWork.Name, InStrRev(fileWork.Name, ".") - 1) & vbLf
            
            End If
    
    
            Set tSreamWork = fsoWork.OpenTextFile(fileWork.Path, 1)
            Set tSreamNew = fsoWork.OpenTextFile(fileWork.Path & ".vbs", 2, True)
            
            Do Until tSreamWork.AtEndOfStream
            
                sLine = tSreamWork.ReadLine
                
                If (boolStart = False) Then
                
                    If (Left(sLine, 1) = "'" Or Left(sLine, 6) = "Option") Then boolStart = True
                    
                End If
                
                If (boolStart = True) Then
                
                    Call clearDeclatations(sLine)
                    Call clearSpecials(sLine)
                    sLine = sLine & vbLf
                    Call tSreamNew.Write(sLine)
                    
                    If (Not sHeadModule = vbNullString) Then
                    
                        sFileIn = sFileIn & sLine
                    
                    End If
                
                End If
                
            Loop
            
            tSreamWork.Close
            tSreamNew.Close
            Set tSreamWork = Nothing
            Set tSreamNew = Nothing
        
            If (Right(fileWork.Name, 4) = ".cls") Then
            
                sFileIn = sFileIn & "End Class" & vbLf
                
            ElseIf (fileWork.Name = sHeadModule) Then
            
                sFileIn = Replace(sFileIn, "Sub CATMain()", "Sub CATMain()" & vbLf & "End Sub" & vbLf & "call startMethod" & vbLf & "Public sub startMethod()")
            
            End If
        
            If (Not sHeadModule = vbNullString) Then
            
                sTotal = sTotal & sFileIn & vbLf
                sTotal = Replace(sTotal, "Option Explicit", "")
            
            End If
        
        End If
    
    Next 'fileWork
    
    If (Not sHeadModule = vbNullString) Then
    
        Set tSreamNew = fsoWork.OpenTextFile(sFolder & "\" & sHeadModule & ".vbs", 2, True)
        Call tSreamNew.Write(sTotal)
        tSreamNew.Close
        Set tSreamNew = Nothing
        
    End If

'End Sub

Private Sub fillArrOfDeclarations()

    ReDim priv_arrOfDeclarations(11)
    
    priv_arrOfDeclarations(0) = "Byte"
    priv_arrOfDeclarations(1) = "Boolean"
    priv_arrOfDeclarations(2) = "Currency"
    priv_arrOfDeclarations(3) = "Date"
    priv_arrOfDeclarations(4) = "Decimal"
    priv_arrOfDeclarations(5) = "Double"
    priv_arrOfDeclarations(6) = "Integer"
    priv_arrOfDeclarations(7) = "Long"
    priv_arrOfDeclarations(8) = "Object"
    priv_arrOfDeclarations(9) = "Single"
    priv_arrOfDeclarations(10) = "String"
    priv_arrOfDeclarations(11) = "Variant"

End Sub

Private Sub clearDeclatations(ByRef io_sLine) ' As String)

    Dim iDeclaration 'As Integer
    
    For iDeclaration = 0 To UBound(priv_arrOfDeclarations)
    
        io_sLine = Replace(io_sLine, " As " & priv_arrOfDeclarations(iDeclaration) & "()", "")
        io_sLine = Replace(io_sLine, " As " & priv_arrOfDeclarations(iDeclaration), "")
    
    Next 'iDeclaration

End Sub

Private Sub clearSpecials(ByRef io_sLine)' As String)

    io_sLine = Replace(io_sLine, "Next ", " Next '")
    io_sLine = Replace(io_sLine, "vbNullString", """""")

End Sub

Private Function BrowseFolder(myStartLocation, blnSimpleDialog)
' This function generates a Browse Folder dialog
' and returns the selected folder as a string.
'
' Arguments:
' myStartLocation   [string]  start folder for dialog, or "My Computer", or
'                             empty string to open in "Desktop\My Documents"
' blnSimpleDialog   [boolean] if False, an additional text field will be
'                             displayed where the folder can be selected
'                             by typing the fully qualified path
'
' Returns:          [string]  the fully qualified path to the selected folder
'
' Based on the Hey Scripting Guys article
' "How Can I Show Users a Dialog Box That Only Lets Them Select Folders?"
' http://www.microsoft.com/technet/scriptcenter/resources/qanda/jun05/hey0617.mspx
'
' Function written by Rob van der Woude
' http://www.robvanderwoude.com
    Const MY_COMPUTER = &H11&
    Const WINDOW_HANDLE = 0 ' Must ALWAYS be 0

    Dim numOptions, objFolder, objFolderItem
    Dim objPath, objShell, strPath, strPrompt

    ' Set the options for the dialog window
    strPrompt = "Select a folder:"
    If blnSimpleDialog = True Then
        numOptions = 0      ' Simple dialog
    Else
        numOptions = &H10&  ' Additional text field to type folder path
    End If
    
    ' Create a Windows Shell object
    Set objShell = CreateObject("Shell.Application")

    ' If specified, convert "My Computer" to a valid
    ' path for the Windows Shell's BrowseFolder method
    If UCase(myStartLocation) = "MY COMPUTER" Then
        Set objFolder = objShell.Namespace(MY_COMPUTER)
        Set objFolderItem = objFolder.Self
        strPath = objFolderItem.Path
    Else
        strPath = myStartLocation
    End If

    Set objFolder = objShell.BrowseForFolder(WINDOW_HANDLE, strPrompt, _
                                              numOptions, strPath)

    ' Quit if no folder was selected
    If objFolder Is Nothing Then
        BrowseFolder = ""
        Exit Function
    End If

    ' Retrieve the path of the selected folder
    Set objFolderItem = objFolder.Self
    objPath = objFolderItem.Path

    ' Return the path of the selected folder
    BrowseFolder = objPath
End Function
